//this file is part of notepad++
//Copyright (C)2003 Don HO ( donho@altern.org )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

/* This .h file is tested to be compatible with 
     MinGW32/GCC 3.44
     Microsoft Visual C++ Toolkit 2003 + Platform SDK
     Borland C++ 5.51
     Digital Mars 845
     OpenWatcom 1.3
     Bloodshed Dev-C++ IDE
     Code::Blocks IDE 
   for both .C and .CPP sources */

#ifndef PLUGININTERFACE_H
#define PLUGININTERFACE_H

#ifndef HINSTANCE
#include <windows.h>
#endif

#define PLAT_WIN 1
#ifndef SCINTILLA_H
#include "scintilla.h"
#endif

#if BUILDING_DLL /* Dev-C++ */ || defined(BUILD_DLL) /* Codeblocks */
# define DLLIMPORT __declspec(dllexport)
#else /* Not BUILDING_DLL */
# define DLLIMPORT __declspec(dllimport)
#error All Notepad++ plugins are DLL's. Please set your compiler to produce a Win32 DLL.
#endif /* Not BUILDING_DLL */

#define NOTEPADPLUS_USER   (WM_USER + 1000)
#define	RUNCOMMAND_USER    (WM_USER + 3000)

#define WM_GETCURRENTSCINTILLA  (NOTEPADPLUS_USER + 4)
#define WM_GETCURRENTLANGTYPE  (NOTEPADPLUS_USER + 5)

enum LangType {L_TXT, L_PHP , L_C, L_CPP, L_CS, L_OBJC, L_JAVA, L_RC, L_HTML, L_XML, L_MAKEFILE, L_PASCAL, L_BATCH, L_INI, L_NFO,\
               L_USER, L_ASP, L_SQL, L_VB, L_JS, L_CSS, L_PERL, L_PYTHON, L_LUA, L_TEX, L_FORTRAN, L_BASH, L_FLASH, L_NSIS};

#define FULL_CURRENT_PATH 1
#define CURRENT_DIRECTORY 2
#define FILE_NAME 3

#define WM_GET_FULLCURRENTPATH (RUNCOMMAND_USER + FULL_CURRENT_PATH)
#define WM_GET_CURRENTDIRECTORY (RUNCOMMAND_USER + CURRENT_DIRECTORY)
#define WM_GET_FILENAME (RUNCOMMAND_USER + FILE_NAME)

struct NppData {
	HWND _nppHandle;
	HWND _scintillaMainHandle;
	HWND _scintillaSecondHandle;
};

#ifdef __WATCOMC__
#define QSORT_FCMP
#else
#define QSORT_FCMP __cdecl
#endif

#define itemNameMaxLen 64
/* Having a typedef and a #define seems to cover all the compilers */
//#if !defined(__WATCOMC__) || defined(_cplusplus)
#define PFUNCPLUGINCMD void __cdecl /* Some compilers cannot use the typedef in every case. This define works to alter function declarations with all compilers */
#if !defined(__WATCOMC__) || defined(__cplusplus)
typedef void (__cdecl PFUNCPLUGINCMD_MSC)(); /* MSC is unable to declare variables without a typedef. Compilers other than Watcom prefer this method also but often work with warnings with the #define. */
#else
#define PFUNCPLUGINCMD_MSC PFUNCPLUGINCMD /* Watcom C does not allow conversion between typedefs and nontypedefs whether or not they are identical. */
#endif
struct FuncItem {
	char _itemName[itemNameMaxLen];
	PFUNCPLUGINCMD_MSC *_pFunc;
	int _cmdID; // set by Notepad++, not set by the plugin
	BOOL _init2Check;
};

#ifdef __cplusplus
extern "C" {
#endif

// DllMain seems to be extern "C" in all compilers. We'll guarantee that here!
// In a 2005 Google fight, "BOOL WINAPI DllMain" returned >9,000 hits and "BOOL APIENTRY DllMain" returned >25,000 hits; APIENTRY wins!
BOOL APIENTRY DllMain(HINSTANCE,DWORD,LPVOID);
// 4 mandatory functions for a plugins
const char DLLIMPORT * __cdecl getName(void);
void DLLIMPORT __cdecl setInfo(struct NppData);
void DLLIMPORT __cdecl beNotified(struct SCNotification *);
struct FuncItem DLLIMPORT * __cdecl getFuncsArray(int *);

#ifdef __cplusplus
}
#endif
//#undef DLLIMPORT /* All compilers except for Watcom C implicitly push DLLIMPORT into the function when it is declared in the code. boo hiss! */
#endif /* PLUGININTERFACE_H */
